<script setup lang="ts">
const props = withDefaults(
  defineProps<{
    reuse?: boolean;
    loading?: boolean;
    errorMessage?: string;
    submitLabel?: string;
    reuseLabel?: string;
  }>(),
  {
    loading: false,
    errorMessage: "",
    submitLabel: "Submit",
    reuseLabel: "Submit and reuse",
  },
);

const emit = defineEmits<{
  (e: "submit", cb: () => void): void;
  (e: "reuse", cb: () => void): void;
  (e: "clear", cb: () => void): void;
}>();

const form = ref<HTMLFormElement>();
const resetValidation = () => {
  form.value?.resetValidation();
};

const valid = ref(false);
const submit = () => {
  if (valid.value) {
    emit("submit", resetValidation);
  }
};

const reuseCb = () => {
  if (valid.value) {
    emit("reuse", resetValidation);
  }
};

const reverseCaptcha = ref("");
const errorMessages = computed(() => {
  if (props.errorMessage) {
    return [props.errorMessage];
  }
  if (reverseCaptcha.value) {
    return ["You are a robot!"];
  }
});
</script>

<template>
  <v-card elevation="3" max-width="640">
    <v-card-text>
      <v-form ref="form" v-model="valid" @submit.prevent>
        <slot />
        <div class="mt-1">
          <v-text-field
            v-model="reverseCaptcha"
            class="form-error"
            :error-messages="errorMessages"
          />
        </div>
        <div class="font-italic mt-2">*: required fields</div>
        <slot name="actions">
          <v-btn
            block
            class="text-none mb-4 mt-2"
            size="x-large"
            color="primary"
            variant="flat"
            :disabled="props.loading || !valid"
            :loading="props.loading"
            @click="submit"
            >{{ props.submitLabel }}</v-btn
          >
          <v-btn
            v-if="props.reuse"
            block
            class="text-none mb-4 mt-2"
            size="x-large"
            color="primary"
            variant="flat"
            :disabled="props.loading || !valid"
            :loading="props.loading"
            @click="reuseCb"
            >{{ props.reuseLabel }}</v-btn
          >
          <v-btn
            block
            color="grey-lighten-3"
            size="x-large"
            variant="flat"
            class="text-none"
            @click="emit('clear', resetValidation)"
            >Clear</v-btn
          >
        </slot>
      </v-form>
    </v-card-text>
  </v-card>
</template>

<style scoped>
:deep(.form-error .v-input__control) {
  display: none;
}
</style>
